#
# Conditional build:
%bcond_without	tcmalloc	# don't use tcmalloc

%ifarch x32
%undefine	with_tcmalloc
%endif

Summary:	Tools for the XFS filesystem
Summary(pl.UTF-8):	Narzędzia do systemu plików XFS
Name:		xfsprogs
Version:	4.2.0
Release:	1
License:	LGPL v2.1 (libhandle), GPL v2 (the rest)
Group:		Applications/System
Source0:	ftp://linux-xfs.sgi.com/projects/xfs/cmd_tars/%{name}-%{version}.tar.gz
# Source0-md5:	e1b9438d3e6775b9df52cc9a13e9f9a6
Source1:	xfs_lsprojid
Patch0:		%{name}-miscfix-v2.patch
Patch1:		%{name}-pl.po-update.patch
Patch2:		%{name}-noquotasync.patch
URL:		http://www.xfs.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bash
BuildRequires:	gettext-tools
BuildRequires:	glibc-static
BuildRequires:	libblkid-devel
%{?with_tcmalloc:BuildRequires:	libtcmalloc-devel}
BuildRequires:	libtool
BuildRequires:	libuuid-devel
BuildRequires:	libuuid-static
BuildRequires:	readline-devel
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.402
%{?with_tcmalloc:Requires:	libtcmalloc >= 1.8.3-3}
Obsoletes:	xfsprogs-initrd
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if "%{pld_release}" == "ac"
# libtool in ac doesn't do the reordering of args properly
%define		filterout_ld -Wl,--as-needed
%endif

%define		_sbindir	/sbin
%define		_bindir		/usr/sbin
%define		_libdir		/%{_lib}
%define		_libexecdir	/usr/%{_lib}

%description
A set of commands to use the XFS filesystem, including mkfs.xfs.

XFS is a high performance journaling filesystem which originated on
the SGI IRIX platform. It is completely multi-threaded, can support
large files and large filesystems, extended attributes, variable block
sizes, is extent based, and makes extensive use of Btrees
(directories, extents, free space) to aid both performance and
scalability.

This implementation is on-disk compatible with the IRIX version of
XFS.

%description -l pl.UTF-8
Zbiór komend do użytku z systemem plików XFS, włączając w to mkfs.xfs.

XFS jest wysoko wydajnym systemem plików z kroniką, który oryginalnie
był używany na platformie SGI IRIX. Jest to w pełni wielowątkowy,
obsługujący wielkie pliki oraz wielkie systemy, o rozszerzonych
atrybutach, zmiennych wielkościach bloków, mocno wykorzystujący
B-drzewa by uzyskać wysoką wydajność oraz skalowalność.

%package devel
Summary:	Header files and libraries to develop XFS software
Summary(pl.UTF-8):	Pliki nagłówkowe i biblioteki
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libuuid-devel

%description devel
Header files and libraries to develop software which operates on XFS
filesystems.

%description devel -l pl.UTF-8
Pliki nagłówkowe i biblioteki potrzebne do rozwoju oprogramowania
operującego na systemie plików XFS.

%package static
Summary:	Static XFS software libraries
Summary(pl.UTF-8):	Biblioteki statyczne do XFS
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static XFS software libraries.

%description static -l pl.UTF-8
Biblioteki statyczne do XFS.

%prep
%setup -q
%patch0 -p1
#%patch1 -p1
%patch2 -p1

%build
%{__aclocal} -I m4
%{__autoconf}
%configure \
	--sbindir=%{_bindir}\
	--enable-gettext \
	--enable-readline \
	--enable-blkid \
	DEBUG="%{?debug:-DDEBUG}%{!?debug:-DNDEBUG}" \
	OPTIMIZER="%{rpmcflags}"

%{__make} -j1 \
	V=1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libexecdir},/etc}

DIST_ROOT=$RPM_BUILD_ROOT
DIST_INSTALL=$(pwd)/install.manifest
DIST_INSTALL_DEV=$(pwd)/install-dev.manifest
export DIST_ROOT DIST_INSTALL DIST_INSTALL_DEV

%{__make} install \
	DIST_MANIFEST="$DIST_INSTALL"
%{__make} install-dev \
	DIST_MANIFEST="$DIST_INSTALL_DEV"

install %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/xfs_lsprojid

ln -sf %{_libdir}/$(basename $RPM_BUILD_ROOT%{_libdir}/libhandle.so.*.*.*) \
	 $RPM_BUILD_ROOT%{_libexecdir}/libhandle.so

mv $RPM_BUILD_ROOT%{_libdir}/lib*.la $RPM_BUILD_ROOT%{_libexecdir}
mv $RPM_BUILD_ROOT%{_libdir}/lib*.a $RPM_BUILD_ROOT%{_libexecdir}

%{__sed} -i -e "s|libdir='%{_libdir}'|libdir='%{_libexecdir}'|" \
	$RPM_BUILD_ROOT%{_libexecdir}/libhandle.la

echo "#10:/mnt/ftp/roman"  >> $RPM_BUILD_ROOT/etc/projects
echo "#ftproman:10" >> $RPM_BUILD_ROOT/etc/projid

%find_lang %{name}

%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}

# already in /usr
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libhandle.so

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc README doc/{CHANGES,CREDITS}
%config(noreplace) %verify(not md5 mtime size) /etc/projects
%config(noreplace) %verify(not md5 mtime size) /etc/projid
%attr(755,root,root) %{_sbindir}/fsck.xfs
%attr(755,root,root) %{_sbindir}/mkfs.xfs
%attr(755,root,root) %{_sbindir}/xfs_repair
%attr(755,root,root) %{_bindir}/xfs_*
%attr(755,root,root) %{_libdir}/libhandle.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libhandle.so.1
%{_mandir}/man5/projects.5*
%{_mandir}/man5/projid.5*
%{_mandir}/man5/xfs.5*
%{_mandir}/man8/fsck.xfs.8*
%{_mandir}/man8/mkfs.xfs.8*
%{_mandir}/man8/xfs_*.8*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libexecdir}/libhandle.so
%{_libexecdir}/libhandle.la
%{_includedir}/xfs
%{_mandir}/man3/*handle.3*
%{_mandir}/man3/xfsctl.3*

%files static
%defattr(644,root,root,755)
%{_libexecdir}/libhandle.a
%changelog
* Tue Sep 29 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xfsprogs.git;a=log;h=master

* Tue Sep 29 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> bba2b36
- up to 4.2.0

* Thu Jul 30 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 673f523
- up to 3.2.4; fixes CVE-2012-2150 (infoleak)

* Wed Jun 10 2015 Jan Rękorajski <baggins@pld-linux.org> 7f3b3fd
- BR static libs for xfs_copy
- rel 2

* Wed Jun 10 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 661ed87
- up to 3.2.3; back to glibc memory alloc functions (we don't want to diverge from upstream too much)

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 6ca06c4
- x32 rebuild
- release 2 (by relup.sh)

* Tue Dec 30 2014 Jan Rękorajski <baggins@pld-linux.org> d9432d7
- no tcmalloc on x32

* Sun Dec 28 2014 Jan Rękorajski <baggins@pld-linux.org> 7fb2d2e
- updated gettext BR

* Wed Dec 03 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> b6d794e
- up to 3.2.2

* Tue Jul 15 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> a7a3a49
- up to 3.2.1

* Wed Jul 09 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 167e999
- rel 4; more fixes

* Tue Jul 08 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 3d58581
- rel 3; important fixes from git (these will be in 3.2.1)

* Thu May 22 2014 Jakub Bogusz <qboosh@pld-linux.org> 5ac6ff9
- updated pl.po-update patch

* Tue May 20 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 7e95678
- rel 2

* Tue May 20 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 8e06f9d
- drop creating shared libxfs, libxlog, libxcmd... thse never meant to be public shared libraries; the only public library is libhandle (xfsdump uses it since 2009); libhandle is properly soname versioned with defined interface etc

* Sat May 17 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 0787bd8
- up to 3.2.0

* Mon Jan 20 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> e33a2d0
- rel 4; ... but drop crc part as not existing in 3.1 xfsprogs series

* Mon Jan 20 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 1d94219
- rel 3; clean garbage from superblocks

* Tue May 14 2013 Jan Rękorajski <baggins@pld-linux.org> 7c029ef
- drop initrd stuff
- rel 2

* Fri May 10 2013 Jakub Bogusz <qboosh@pld-linux.org> f8e9104
- updated pl.po-update patch

* Thu May 09 2013 Jakub Bogusz <qboosh@pld-linux.org> adcc007
- force ld.bfd for dietlibc build (gold gets hit by internal error on x86)

